
#include <Servo.h>
#include <AccelStepper.h>

const int sensorPin = A0;  // Analog input pin that senses Vout
int sensorValue = 0;       // sensorPin default value
float Vin = 5;             // Input voltage
float Vout = 0;            // Vout default value
float Rref = 10;           // Reference resistor's value in ohms (you can give this value in kiloohms or megaohms - the resistance of the tested resistor will be given in the same units)
float R = 0;               // Tested resistors default value



//-- StepMotors

const int In1 = 8;
const int In2 = 9;
const int In3 = 10;
const int In4 = 11;

bool reachedEnd = false;

const int stepsPerRevolution = 2048;

AccelStepper myStepper(AccelStepper::FULL4WIRE, In1, In3, In2, In4);

//-- PenServo

Servo penservo;
int pospenservo = 0;
int penservospeed = 1;


//-- MoistureServo

Servo moistureservo;

int posmoistureservo = 90;
int moistureservospeed = 30;
int readpos;


// -- MAX/LOW DEFINITION FROM SENSOR READ

float MaxV = 5.5;
float MinV = 1;
float MaxDeltaV = MaxV-MinV;

float NValueH = 90;
float NValueL = 1;


//  -- SERVO CONTROL VARIABLES
int dir = 1;
int target;
int currentPos = 45;
int stepSize = 1;
int loopCount = 0;
int amp;
bool escape = false;




void setup() //--------------------------------------------------------------------------------

{

  penservo.attach(5);
  
  moistureservo.attach(6);
 
  pinMode(3,INPUT); // IR Sensor



  myStepper.moveTo(4000);
  myStepper.setMaxSpeed(700);
  myStepper.setAcceleration(300);
  Serial.begin(9600);

 
}

void loop() //--------------------------------------------------------------------------------

{

  // step servo to center once
  if(loopCount == 0) penservo.write(currentPos);
  loopCount +=1;

  moistureservo.write(90);
  
  if (digitalRead(3)== LOW) //IR SENSOR READ
  {

    if (reachedEnd == false);
    {
    //---------Moisture Measurement


                  if (reachedEnd == false ) 
                  { 
                  moistureservo.write(0);
                 
        //----------------- MOISTURESERVO DOWN ---------------
      
      
                  // ---------- SensorRead -------
                  sensorValue = analogRead(sensorPin);  // Read Vout on analog input pin A0 (Arduino can sense from 0-1023, 1023 is 5V)
                  Vout = (Vin * sensorValue) / 1023;    // Convert Vout to volts
                  R = Rref * (1 / ((Vin / Vout) - 1));  // Formula to calculate tested resistor's value
                  Serial.print("R: ");
                  Serial.println(R);                    // Give calculated resistance in Serial Monitor

                  // MAKE SURE RESISTANCE IS WITHIN NORMAL RANGE
                  if(R > MaxV) R = MaxV;
                  else if(R < MinV) R = MinV;

                  // Normalize SENSORREAD AND MULTIPLY BY MAX DEGREES
                  NValueL =abs((R-MinV)/MaxDeltaV)*90;
                  Serial.print("NValueL: ");                  
                  Serial.println(NValueL);
               
                  NValueH = abs((R-MaxV)/MaxDeltaV)*90;
                  Serial.print("NValueH: ");                  
                  Serial.println(NValueH);
                  delay(100);                          // Delay in milliseconds between reeds

                  amp = 45 + (abs((NValueH - NValueL)/2));
                  
                  delay (3000);
                  moistureservo.write(90);
                  }
                
               

      target = NValueH;

      myStepper.moveTo(6000);  // set target forward steps
      
      }
      
      while (myStepper.distanceToGo() != 0)
   
      {  
        myStepper.run(); 
      
        //Serial.println(myStepper.currentPosition());
        
        if (dir == 1 && currentPos < target )
        {
         currentPos += stepSize * dir;
         penservo.write(currentPos);
         delay (7);
        }
        
        if (dir == -1 && currentPos > target)
        
        {
         currentPos += stepSize * dir;
         penservo.write(currentPos);
         delay (7);
        }

        if ((dir == 1 && currentPos >= target) || (dir == -1 && currentPos <= target))
        
        {

         dir *= -1;
         currentPos = target + (stepSize * dir);
         penservo.write(currentPos);
         target = 45 + (amp * dir);
         delay (7);
            
        }
        

        
        if (digitalRead(3) == HIGH) 
        {
        reachedEnd = true;
        break;
        
        }
        }
        }

      


     if (reachedEnd == true )
      {
       myStepper.moveTo(-17000);
        }
       while (myStepper.distanceToGo() != 0)
       
       {
       myStepper.run();
       }
       {
       myStepper.setCurrentPosition(0);
       }
       }
          


      
      
            
      
  

 
